Subject: Re: [RFC] should we care of COMPAT mode in bridge ?

From: Arnd Bergmann <[email-masked]>
Date: Mon, 6 Jun 2011 22:06:28 +0200

On Monday 06 June 2011 21:45:40 Eric Dumazet wrote:
> While trying Alexander Holler patch, I found a 32bit brctl program was
> not able to work on a 64bit kernel. So I had to switch to another
> machine for my tests.
> 
> brctl addbr mybridge
> ->
> socket(PF_FILE, SOCK_STREAM, 0)         = 3
> ioctl(3, SIOCSIFBR, 0xffd509c0)         = -1 EINVAL (Invalid argument)
> 
> Should we care or not ?
> 

Generally, we try to make all ioctls work in compat mode. For the old
bridge ioctls, this is currently impossible because it uses SIOCPRIVATE
ioctls, but it would be easy to add an ndo_do_compat_ioctl. 

The solution that is documented in net/socket.c is to return 
an invalid version number for BRCTL_VERSION, in the hope that
brctl would switch to the newer interfaces. The new style bridge
ioctls (SIOCBRADDBR, SIOCBRADDIF, ...) are actually supposed to work,
but I've never tried that.

	Arnd